jjb: Use matching ust version for tools long_regression
[lttng-ci.git] / scripts / lttng-modules / param-build.sh
CommitLineData
5a196804 1#!/bin/bash -exu
f3d8604b 2#
1d5a0a3c 3# Copyright (C) 2016-2019 - Michael Jeanson <mjeanson@efficios.com>
f3d8604b
MJ
4#
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 3 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see <http://www.gnu.org/licenses/>.
17
39961776
MJ
18# Parameters
19arch=${arch:-}
20cross_arch=${cross_arch:-}
21ktag=${ktag:-}
5a196804
MJ
22kgitrepo=${kgitrepo:-}
23mversion=${mversion:-}
24mgitrepo=${mgitrepo:-}
39961776
MJ
25
26
339db64d
MJ
27## FUNCTIONS ##
28
f3d8604b
MJ
29# Kernel version compare functions
30verlte() {
51fa2ab3 31 [ "$1" = "$(printf '%s\n%s' "$1" "$2" | sort -V | head -n1)" ]
f3d8604b
MJ
32}
33
34verlt() {
51fa2ab3 35 [ "$1" = "$2" ] && return 1 || verlte "$1" "$2"
f3d8604b
MJ
36}
37
38vergte() {
51fa2ab3 39 [ "$1" = "$(printf '%s\n%s' "$1" "$2" | sort -V | tail -n1)" ]
f3d8604b
MJ
40}
41
42vergt() {
51fa2ab3 43 [ "$1" = "$2" ] && return 1 || vergte "$1" "$2"
f3d8604b
MJ
44}
45
339db64d 46
5a196804
MJ
47git_clone_modules_sources() {
48 mkdir -p "$MODULES_GIT_DIR"
49 git clone --depth=1 -b "${mversion}" "${mgitrepo}" "$MODULES_GIT_DIR"
50}
51
52# Checkout a shallow kernel tree of the specified tag
53git_clone_linux_sources() {
54 mkdir -p "$LINUX_GIT_DIR"
55 git clone --depth=1 -b "${ktag}" --reference "$LINUX_GIT_REF_REPO_DIR" "${kgitrepo}" "$LINUX_GIT_DIR"
56}
7e02032c 57
7e02032c 58
5a196804
MJ
59# Export the kernel sources from the git repo
60git_export_linux_sources() {
61 cd "$LINUX_GIT_DIR"
62 git archive "${ktag}" | tar -x -C "$LINUX_SRCOBJ_DIR"
63}
64
65
66# Upload the tar archive to the object store
67upload_archive_obj() {
68 s3cmd -c "$WORKSPACE/.s3cfg" put "$WORKSPACE/$obj_name" "$obj_url_prefix/"
69 rm -f "$WORKSPACE/$obj_name"
70}
71
72
73extract_archive_obj() {
74 tar -xf "$WORKSPACE/$obj_name" -C "$LINUX_OBJ_DIR"
75 rm -f "$WORKSPACE/$obj_name"
76}
77
78
79tar_archive_obj() {
80 cd "$LINUX_OBJ_DIR"
81 tar -cf "$WORKSPACE/$obj_name" -I pbzip2 .
82 cd -
83}
84
85# Find the most recent GCC version supported by the kernel sources
86select_compiler() {
87 local selected_cc
88
89 cd "$LINUX_SRCOBJ_DIR"
90
91 kversion=$(make -s kernelversion)
92
93 set +e
94
1d5a0a3c 95 for cc in gcc-5 gcc-4.8; do
5a196804
MJ
96 if "${CROSS_COMPILE:-}${cc}" -I include/ -D__LINUX_COMPILER_H -D__LINUX_COMPILER_TYPES_H -E include/linux/compiler-gcc.h; then
97 selected_cc="$cc"
98 break
99 fi
100 done
101
102 set -e
103
104 if [ "x$selected_cc" = "x" ]; then
105 echo "Found no suitable compiler."
106 exit 1
107 fi
108
1d5a0a3c
MJ
109 # Force gcc-4.8 for kernels before 3.18
110 if { verlt "$kversion" "3.18"; }; then
23db2292 111 selected_cc=gcc-4.8
7e02032c
MJ
112 fi
113
425e4992
MJ
114 if [ "$selected_cc" != "gcc-4.8" ]; then
115 # Older kernel Makefiles do not expect the compiler to default to PIE
116 KAFLAGS="-fno-pie"
c45b04df 117 KCFLAGS="-fno-pie -no-pie -fno-stack-protector"
425e4992
MJ
118 KCPPFLAGS="-fno-pie"
119 export KAFLAGS KCFLAGS KCPPFLAGS
120 fi
121
5a196804 122 export CC="${CROSS_COMPILE:-}${selected_cc}"
1d5a0a3c 123 export HOSTCC="${selected_cc}"
5a196804
MJ
124
125 cd -
126}
127
128
129build_linux_kernel() {
130 cd "$LINUX_SRCOBJ_DIR"
131
132 kversion=$(make -s kernelversion)
133
7e02032c 134 # Generate kernel configuration
a1ae361e 135 case "$ktag" in
7e02032c 136 Ubuntu*)
39961776 137 if [ "${cross_arch}" = "powerpc" ]; then
5a196804 138 if vergte "${kversion}" "4.10"; then
39961776
MJ
139 echo "Ubuntu removed big endian powerpc configuration from kernel >= 4.10. Don't try to build it."
140 exit 0
141 fi
142 fi
a46abb0a
MJ
143 fakeroot debian/rules clean KW_DEFCONFIG_DIR=.
144 fakeroot debian/rules genconfigs KW_DEFCONFIG_DIR=.
5a196804 145 cp CONFIGS/"${ubuntu_config}" .config
7e02032c 146 ;;
c45b04df 147
7e02032c 148 *)
16844a6d
MJ
149 # Force 32bit build on i386, default is 64bit
150 if [ "$arch" = "i386" ]; then
5a196804
MJ
151 export ARCH="i386"
152 fi
153
154 # allyesconfig is mostly broken for kernels of the 2.6 series
155 if verlt "$kversion" "3.0"; then
156 vanilla_config="defconfig"
7a76a4d0
MJ
157 fi
158
5a196804 159 make "${vanilla_config}"
7e02032c
MJ
160 ;;
161 esac
162
53b51a15 163 # oldnoconfig was renamed in 4.19
5a196804 164 if vergte "$kversion" "4.19"; then
53b51a15 165 update_conf_target="olddefconfig"
5a196804 166 else
53b51a15 167 update_conf_target="oldnoconfig"
5a196804
MJ
168 fi
169
170 # Fix 'defined(@array)' was removed from recent perl
171 if [ -f "kernel/timeconst.pl" ]; then
172 sed -i 's/defined(\@\(.*\))/@\1/' kernel/timeconst.pl
173 fi
174
175 # Fix syntax of inline assembly which is confused with C++11 raw strings on gcc >= 5
53b51a15 176 if [ "$HOSTCC" != "gcc-4.8" ]; then
5a196804
MJ
177 if [ -f "arch/x86/kvm/svm.c" ]; then
178 sed -i 's/ R"/ R "/g; s/"R"/" R "/g' arch/x86/kvm/svm.c
179 fi
180
181 if [ -f "arch/x86/kvm/vmx.c" ]; then
182 sed -i 's/ R"/ R "/g; s/"R"/" R "/g' arch/x86/kvm/vmx.c
183 fi
184 fi
185
53b51a15
MJ
186 # Newer binutils don't accept 3 operand 'cmp' instructions on ppc64
187 # Convert them to 'cmpw' which was previously done silently
188 if verlt "$kversion" "4.9"; then
189 find arch/powerpc/ -name "*.S" -print0 | xargs -0 sed -i "s/\(cmp\)\(\s\+[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+\)/cmpw\2/"
190 find arch/powerpc/ -name "*.S" -print0 | xargs -0 sed -i "s/\(cmpli\)\(\s\+[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+\)/cmplwi\2/"
191 sed -i "s/\$pie \-o \"\$ofile\"/\$pie --no-dynamic-linker -o \"\$ofile\"/" arch/powerpc/boot/wrapper
192 fi
193
5a196804
MJ
194 # Fix a typo in v2.6.36.x
195 if [ -f "arch/x86/kernel/entry_64.S" ]; then
196 sed -i 's/END(do_hypervisor_callback)/END(xen_do_hypervisor_callback)/' arch/x86/kernel/entry_64.S
197 fi
198
53b51a15
MJ
199 # Fix compiler switch in vdso Makefile for 2.6.36 to 2.6.36.2
200 if { vergte "$kversion" "2.6.36" && verlte "$kversion" "2.6.36.3"; }; then
201 sed -i 's/-m elf_x86_64/-m64/' arch/x86/vdso/Makefile
202 sed -i 's/-m elf_i386/-m32/' arch/x86/vdso/Makefile
203 fi
204
5a196804
MJ
205 # Fix kernel < 3.0 with gcc >= 4.7
206 if verlt "$kversion" "3.0"; then
207 sed -i '/linux\/compiler.h/a #include <linux\/linkage.h> \/* For asmregparm *\/' arch/x86/include/asm/ptrace.h
208 sed -i 's/extern long syscall_trace_enter/extern asmregparm long syscall_trace_enter/' arch/x86/include/asm/ptrace.h
209 sed -i 's/extern void syscall_trace_leave/extern asmregparm void syscall_trace_leave/' arch/x86/include/asm/ptrace.h
210 echo "header-y += linkage.h" >> include/linux/Kbuild
211 fi
212
7e02032c 213 # GCC 4.8
53b51a15
MJ
214 if [ "$HOSTCC" == "gcc-4.8" ]; then
215 scripts/config --disable CONFIG_CC_STACKPROTECTOR_STRONG
216 fi
7e02032c
MJ
217
218 # Don't try to sign modules
53b51a15 219 scripts/config --disable CONFIG_MODULE_SIG
7e02032c 220
9ef18fa2 221 # Disable kernel stack frame correctness validation, introduced in 4.6.0 and currently fails
53b51a15 222 scripts/config --disable CONFIG_STACK_VALIDATION
5a196804
MJ
223
224 # Cause problems with inline assembly on i386
53b51a15 225 scripts/config --disable CONFIG_DEBUG_SECTION_MISMATCH
5a196804 226
1d5a0a3c 227 # Don't build samples, they are broken on some kernel releases
53b51a15
MJ
228 scripts/config --disable CONFIG_SAMPLES
229 scripts/config --disable CONFIG_BUILD_DOCSRC
c45b04df
MJ
230
231 # Disable kcov
53b51a15 232 scripts/config --disable CONFIG_KCOV
c45b04df
MJ
233
234 # Broken on some RT kernels
53b51a15 235 scripts/config --disable CONFIG_HYPERV
1d5a0a3c 236
1e300ea9 237 # Broken drivers
53b51a15
MJ
238 scripts/config --disable CONFIG_RAPIDIO_TSI721
239 scripts/config --disable CONFIG_SGI_XP
240 scripts/config --disable CONFIG_MFD_WM8994
241 scripts/config --disable CONFIG_DRM_RADEON
242 scripts/config --disable CONFIG_SND_SOC_WM5100
1e300ea9 243
5a196804
MJ
244 # IGBVF won't build with recent gcc on 2.6.38.x
245 if { vergte "$kversion" "2.6.37" && verlt "$kversion" "2.6.38"; }; then
53b51a15 246 scripts/config --disable CONFIG_IGBVF
5a196804 247 fi
9ef18fa2 248
51fa2ab3 249 # Set required options
53b51a15
MJ
250 scripts/config --enable CONFIG_TRACEPOINTS
251 scripts/config --enable CONFIG_KALLSYMS
252 scripts/config --enable CONFIG_HIGH_RES_TIMERS
253 scripts/config --enable CONFIG_KPROBES
254 scripts/config --enable CONFIG_FTRACE
255 scripts/config --enable CONFIG_BLK_DEV_IO_TRACE
256 scripts/config --enable CONFIG_KALLSYMS_ALL
257 scripts/config --enable CONFIG_HAVE_SYSCALL_TRACEPOINTS
258 scripts/config --enable CONFIG_PERF_EVENTS
259 scripts/config --enable CONFIG_EVENT_TRACING
260 scripts/config --enable CONFIG_KRETPROBES
7e02032c 261
7a76a4d0 262 # Debug
5a196804
MJ
263 #cat .config
264
265 make "$update_conf_target" CC="$CC"
266 make -j"$NPROC" CC="$CC"
267
c45b04df 268 krelease=$(make -s kernelrelease CC="$CC")
5a196804
MJ
269
270 # Save the kernel and modules
271 mkdir -p "$LINUX_INSTOBJ_DIR/boot"
53b51a15
MJ
272 make INSTALL_MOD_PATH="$LINUX_INSTOBJ_DIR" INSTALL_MOD_STRIP=1 modules_install CC="$CC"
273 make INSTALL_PATH="$LINUX_INSTOBJ_DIR/boot" install CC="$CC"
5a196804
MJ
274 rm -f "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source" "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/build"
275 ln -s ../../../../sources "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source"
276 ln -s ../../../../sources "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source"
277}
278
279
280extract_distro_headers() {
281
282 # Enter linux source dir
283 cd "${LINUX_SRCOBJ_DIR}"
284
285
286 # For RT kernels, copy version file
287 if [ -s localversion-rt ]; then
288 cp -a localversion-rt "${LINUX_HDROBJ_DIR}"
289 fi
290
291 # Copy all Makefile related stuff
292 find . -path './include/*' -prune \
293 -o -path './scripts/*' -prune -o -type f \
294 \( -name 'Makefile*' -o -name 'Kconfig*' -o -name 'Kbuild*' -o \
295 -name '*.sh' -o -name '*.pl' -o -name '*.lds' \) \
296 -print | cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
297
298 # Copy base scripts and include dirs
299 cp -a scripts include "${LINUX_HDROBJ_DIR}"
7e02032c 300
5a196804
MJ
301 # Copy arch includes
302 (find arch -name include -type d -print0 | \
303 xargs -0 -n1 -i: find : -type f) | \
304 cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
305
306 # Copy arch scripts
307 (find arch -name scripts -type d -print0 | \
308 xargs -0 -n1 -i: find : -type f) | \
309 cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
310
311 # Cleanup scripts
312 rm -f "${LINUX_HDROBJ_DIR}/scripts/*.o"
313 rm -f "${LINUX_HDROBJ_DIR}/scripts/*/*.o"
314
315 # On powerpc this object is required to link modules
316 if [ "${karch}" = "powerpc" ]; then
317 cp -a --parents arch/powerpc/lib/crtsavres.[So] "${LINUX_HDROBJ_DIR}/"
318 fi
319
320 # On arm64 between 4.13 and 1.15 this object is required to build with ftrace support
321 if [ "${karch}" = "arm64" ]; then
322 if [ -f "arch/arm64/kernel/ftrace-mod.S" ]; then
323 cp -a --parents arch/arm64/kernel/ftrace-mod.[So] "${LINUX_HDROBJ_DIR}/"
324 fi
325 fi
326
327 # Newer kernels need objtool to build modules when CONFIG_STACK_VALIDATION=y
328 if [ -f tools/objtool/objtool ]; then
329 cp -a --parents tools/objtool/objtool "${LINUX_HDROBJ_DIR}/"
330 fi
331
332 if [ -f "arch/x86/kernel/macros.s" ]; then
333 cp -a --parents arch/x86/kernel/macros.s "${LINUX_HDROBJ_DIR}/"
334 fi
335
336 # Copy modules related stuff, if available
337 if [ -s Module.symvers ]; then
338 cp Module.symvers "${LINUX_HDROBJ_DIR}"
339 fi
340
341 if [ -s System.map ]; then
342 cp System.map "${LINUX_HDROBJ_DIR}"
343 fi
344
345 if [ -s Module.markers ]; then
346 cp Module.markers "${LINUX_HDROBJ_DIR}"
347 fi
348
349 # Copy config file
350 cp .config "${LINUX_HDROBJ_DIR}"
351
352 # Make sure the Makefile and version.h have a matching timestamp so that
353 # external modules can be built
354 if [ -s "${LINUX_HDROBJ_DIR}/include/generated/uapi/linux/version.h" ]; then
355 touch -r "${LINUX_HDROBJ_DIR}/Makefile" "${LINUX_HDROBJ_DIR}/include/generated/uapi/linux/version.h"
356 elif [ -s "${LINUX_HDROBJ_DIR}/include/linux/version.h" ]; then
357 touch -r "${LINUX_HDROBJ_DIR}/Makefile" "${LINUX_HDROBJ_DIR}/include/linux/version.h"
358 else
359 echo "Missing version.h"
360 exit 1
361 fi
362 touch -r "${LINUX_HDROBJ_DIR}/.config" "${LINUX_HDROBJ_DIR}/include/generated/autoconf.h"
363
364 # Copy .config to include/config/auto.conf so "make prepare" is unnecessary.
365 cp "${LINUX_HDROBJ_DIR}/.config" "${LINUX_HDROBJ_DIR}/include/config/auto.conf"
366
367 # Finally clean the object files from the full source tree
368 make clean
369
370 # And regen the modules support files
371 make modules_prepare CC="$CC"
51fa2ab3 372
d815b018
MJ
373 # On powerpc this object is required to link modules
374 if [ "${karch}" = "powerpc" ]; then
5a196804 375 make arch/powerpc/lib/crtsavres.o CC="$CC"
d815b018
MJ
376 fi
377
7a76a4d0 378 # On arm64 between 4.13 and 4.15 this object is required to build with ftrace support
a1ae361e 379 if [ "${karch}" = "arm64" ]; then
c236528e 380 if [ -f "arch/arm64/kernel/ftrace-mod.S" ]; then
5a196804 381 make arch/arm64/kernel/ftrace-mod.o CC="$CC"
a1ae361e
MJ
382 fi
383 fi
384
7e02032c 385 # Version specific tasks
a1ae361e 386 case "$ktag" in
7e02032c
MJ
387 Ubuntu*)
388 # Add Ubuntu ABI number to kernel headers, this is normally done by the packaging code
a1ae361e 389 ABINUM="$(echo "$ktag" | grep -P -o 'Ubuntu-(lts-)?.*-\K\d+(?=\..*)')"
5a196804
MJ
390 echo "#define UTS_UBUNTU_RELEASE_ABI $ABINUM" >> include/generated/utsrelease.h
391 echo "#define UTS_UBUNTU_RELEASE_ABI $ABINUM" >> "${LINUX_HDROBJ_DIR}/include/generated/utsrelease.h"
7e02032c
MJ
392 ;;
393 esac
7e02032c
MJ
394}
395
396
339db64d
MJ
397build_modules() {
398
5a196804
MJ
399 local kdir="$1"
400 local outdir="$2"
401 local kversion
402
403 kversion=$(make -C "$LINUX_HDROBJ_DIR" -s kernelversion)
339db64d 404
339db64d 405 # Enter lttng-modules source dir
5a196804 406 cd "${MODULES_GIT_DIR}"
339db64d
MJ
407
408 # kernels 3.10 to 3.10.13 and 3.11 to 3.11.2 introduce a deadlock in the
409 # timekeeping subsystem. We want those build to fail.
5a196804
MJ
410 if { vergte "$kversion" "3.10" && verlte "$kversion" "3.10.13"; } || \
411 { vergte "$kversion" "3.11" && verlte "$kversion" "3.11.2"; }; then
339db64d
MJ
412
413 set +e
414
415 # Build modules
51fa2ab3 416 KERNELDIR="${kdir}" make -j"${NPROC}" V=1 CC="$CC"
0f71a764 417 ret=$?
339db64d 418
5a196804
MJ
419 set -e
420
339db64d 421 # We expect this build to fail, if it doesn't, fail the job.
0f71a764 422 if [ "$ret" -eq 0 ]; then
e9b44189 423 echo "This build should have failed."
339db64d
MJ
424 exit 1
425 fi
426
427 # We have to publish at least one file or the build will fail
5a196804 428 echo "This kernel is broken, there is a deadlock in the timekeeping subsystem." > "${outdir}/BROKEN.txt.ko"
339db64d 429
5a196804 430 KERNELDIR="${kdir}" make clean
7e02032c 431
339db64d
MJ
432 else # Regular build
433
434 # Build modules against full kernel sources
51fa2ab3 435 KERNELDIR="${kdir}" make -j"${NPROC}" V=1 CC="$CC"
339db64d
MJ
436
437 # Install modules to build dir
5a196804 438 KERNELDIR="${kdir}" make INSTALL_MOD_PATH="${outdir}" modules_install
339db64d
MJ
439
440 # Clean build dir
5a196804 441 KERNELDIR="${kdir}" make clean
339db64d
MJ
442 fi
443}
444
445
446## MAIN ##
447
f3d8604b
MJ
448# Use all CPU cores
449NPROC=$(nproc)
450
5a196804
MJ
451MODULES_GIT_DIR="${WORKSPACE}/src/lttng-modules"
452LINUX_GIT_DIR="${WORKSPACE}/src/linux"
339db64d 453
5a196804
MJ
454LINUX_OBJ_DIR="${WORKSPACE}/linux"
455LINUX_SRCOBJ_DIR="${LINUX_OBJ_DIR}/sources"
456LINUX_HDROBJ_DIR="${LINUX_OBJ_DIR}/headers"
457LINUX_INSTOBJ_DIR="${LINUX_OBJ_DIR}/install"
339db64d 458
5a196804
MJ
459MODULES_OUTPUT_KSRC_DIR="${WORKSPACE}/build/lttng-modules-ksrc"
460MODULES_OUTPUT_KHDR_DIR="${WORKSPACE}/build/lttng-modules-khdr"
339db64d 461
5a196804
MJ
462LINUX_GIT_REF_REPO_DIR="$HOME/gitcache/linux-stable.git/"
463
464OBJ_STORE_URL="s3://jenkins"
465
466cd "$WORKSPACE"
467
468# Create build directories
469mkdir -p "${LINUX_SRCOBJ_DIR}" "${LINUX_HDROBJ_DIR}" "${LINUX_INSTOBJ_DIR}" "${MODULES_OUTPUT_KSRC_DIR}" "${MODULES_OUTPUT_KHDR_DIR}"
470
471git_clone_modules_sources
339db64d 472
7e02032c 473# Setup cross compile env if available
39961776 474if [ "x${cross_arch}" != "x" ]; then
7e02032c
MJ
475
476 case "$cross_arch" in
477 "armhf")
478 karch="arm"
479 cross_compile="arm-linux-gnueabihf-"
53b51a15 480 vanilla_config="imx_v6_v7_defconfig"
7e02032c
MJ
481 ubuntu_config="armhf-config.flavour.generic"
482 ;;
483
484 "arm64")
485 karch="arm64"
486 cross_compile="aarch64-linux-gnu-"
53b51a15 487 vanilla_config="defconfig"
7e02032c
MJ
488 ubuntu_config="arm64-config.flavour.generic"
489 ;;
490
491 "powerpc")
492 karch="powerpc"
493 cross_compile="powerpc-linux-gnu-"
e9b44189 494 vanilla_config="ppc44x_defconfig"
7e02032c
MJ
495 ubuntu_config="powerpc-config.flavour.powerpc-smp"
496 ;;
497
498 "ppc64el")
499 karch="powerpc"
500 cross_compile="powerpc64le-linux-gnu-"
e9b44189 501 vanilla_config="pseries_le_defconfig"
7e02032c
MJ
502 ubuntu_config="ppc64el-config.flavour.generic"
503 ;;
504
505 *)
51fa2ab3 506 echo "Unsupported cross arch $cross_arch"
7e02032c
MJ
507 exit 1
508 ;;
509 esac
339db64d 510
7e02032c
MJ
511 # Export variables used by Kbuild for cross compilation
512 export ARCH="${karch}"
513 export CROSS_COMPILE="${cross_compile}"
339db64d 514
7e02032c 515# Set arch specific values if we are not cross compiling
39961776 516elif [ "x${arch}" != "x" ]; then
e9b44189 517
7e02032c 518 case "$arch" in
16844a6d 519 "i386")
7e02032c 520 karch="x86"
e9b44189 521 vanilla_config="allyesconfig"
7e02032c
MJ
522 ubuntu_config="i386-config.flavour.generic"
523 ;;
524
16844a6d 525 "amd64")
7e02032c 526 karch="x86"
e9b44189 527 vanilla_config="allyesconfig"
7e02032c
MJ
528 ubuntu_config="amd64-config.flavour.generic"
529 ;;
530
531 "armhf")
532 karch="arm"
e9b44189 533 vanilla_config="allyesconfig"
7e02032c
MJ
534 ubuntu_config="armhf-config.flavour.generic"
535 ;;
536
537 "arm64")
538 karch="arm64"
e9b44189 539 vanilla_config="allyesconfig"
7e02032c
MJ
540 ubuntu_config="arm64-config.flavour.generic"
541 ;;
542
543 "powerpc")
544 karch="powerpc"
e9b44189 545 vanilla_config="allyesconfig"
7e02032c
MJ
546 ubuntu_config="powerpc-config.flavour.powerpc-smp"
547 ;;
548
549 "ppc64el")
550 karch="powerpc"
e9b44189 551 vanilla_config="allyesconfig"
7e02032c
MJ
552 ubuntu_config="ppc64el-config.flavour.generic"
553 ;;
554
555 *)
556 echo "Unsupported arch $arch"
557 exit 1
558 ;;
559 esac
560else
561 echo "Not arch or cross_arch specified"
562 exit 1
563fi
339db64d 564
339db64d 565
b214d997 566
5a196804
MJ
567# First get the kernel build from the object store, or build it, if it's
568# not available.
339db64d 569
5a196804
MJ
570echo "# Setup endpoint
571host_base = obj.internal.efficios.com
572host_bucket = obj.internal.efficios.com
573bucket_location = us-east-1
574use_https = True
7e02032c 575
5a196804
MJ
576# Setup access keys
577access_key = jenkins
578secret_key = echo123456
339db64d 579
5a196804
MJ
580# Enable S3 v4 signature APIs
581signature_v2 = False" > "$WORKSPACE/.s3cfg"
339db64d 582
c45b04df 583url_hash="$(echo -n "$kgitrepo" | md5sum | awk '{ print $1 }')"
5a196804 584obj_name="linux.tar.bz2"
c45b04df 585obj_url_prefix="$OBJ_STORE_URL/linux-build/$url_hash/$ktag/$arch/${cross_arch:-native}"
5a196804 586obj_url="$obj_url_prefix/$obj_name"
339db64d 587
5a196804
MJ
588set +e
589s3cmd -c "$WORKSPACE/.s3cfg" get "$obj_url"
590ret=$?
591set -e
339db64d 592
5a196804
MJ
593case "$ret" in
594 "0")
595 extract_archive_obj
596 ;;
a1ae361e 597
5a196804
MJ
598 "12")
599 echo "File not found"
339db64d 600
5a196804
MJ
601 # Build all the things and upload
602 # then finish the module build...
339db64d 603
5a196804
MJ
604 git_clone_linux_sources
605 git_export_linux_sources
339db64d 606
5a196804 607 select_compiler
a1ae361e 608
5a196804
MJ
609 ## PREPARE FULL LINUX SOURCE TREE
610 build_linux_kernel
d138fc44 611
5a196804
MJ
612 ## EXTRACT DISTRO STYLE KERNEL HEADERS / DEVEL
613 extract_distro_headers
339db64d 614
5a196804 615 tar_archive_obj
339db64d 616
5a196804 617 upload_archive_obj
339db64d 618
5a196804 619 ;;
339db64d 620
5a196804
MJ
621 *)
622 echo "Unknown error? Abort"
623 exit 1
624 ;;
625esac
339db64d 626
5a196804 627select_compiler
f3d8604b 628
7e02032c 629## BUILD modules
5a196804
MJ
630# Either we downloaded a pre-build kernel or we built it and uploaded
631# the archive for future builds.
632
633cd "$WORKSPACE"
f3d8604b 634
339db64d 635# Build modules against full kernel sources
5a196804 636build_modules "${LINUX_SRCOBJ_DIR}" "${MODULES_OUTPUT_KSRC_DIR}"
f3d8604b 637
339db64d 638# Build modules against kernel headers
5a196804 639build_modules "${LINUX_HDROBJ_DIR}" "${MODULES_OUTPUT_KHDR_DIR}"
f3d8604b 640
5a196804
MJ
641# Make sure some modules were actually built
642tree "${MODULES_OUTPUT_KSRC_DIR}"
643if [ "x$(find "${MODULES_OUTPUT_KSRC_DIR}" -name '*.ko*' -printf yes -quit)" != "xyes" ]; then
7e02032c
MJ
644 echo "No modules built!"
645 exit 1
646fi
647
5a196804
MJ
648tree "${MODULES_OUTPUT_KHDR_DIR}"
649if [ "x$(find "${MODULES_OUTPUT_KHDR_DIR}" -name '*.ko*' -printf yes -quit)" != "xyes" ]; then
7e02032c
MJ
650 echo "No modules built!"
651 exit 1
652fi
b214d997 653
f3d8604b 654# EOF
This page took 0.056157 seconds and 4 git commands to generate.